package pku.edu.hocra;

import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import pku.edu.hocra.graph.ExplodedGraphBuilder;
import pku.edu.hocra.resource.FileManager;
import soot.MethodOrMethodContext;
import soot.Scene;
import soot.SceneTransformer;
import soot.SootMethod;
import soot.jimple.toolkits.callgraph.Edge;
import soot.jimple.toolkits.callgraph.ReachableMethods;
import soot.util.queue.QueueReader;

public class WholeProgramTransformer extends SceneTransformer {
	
	private String subjectName;
	
	public WholeProgramTransformer(String subjectName) {
		this.subjectName = subjectName;
	}

	@Override
	protected void internalTransform(String arg0, Map<String, String> arg1) {
		
		FileManager.makeDir("dddata/subjects/"+subjectName);
		
		ReachableMethods reachableMethods = Scene.v().getReachableMethods();
		Set<SootMethod> mSet = new HashSet<SootMethod>();
		QueueReader<MethodOrMethodContext> qr = reachableMethods.listener();
		while (qr.hasNext()) {
			SootMethod sm = qr.next().method();
			mSet.add(sm);
		}
		System.out.println("|WholeMtd|=" + mSet.size());
		System.out.println("|CG Edge|=" + Scene.v().getCallGraph().size());
		try {
			ExplodedGraphBuilder egb = new ExplodedGraphBuilder(Scene.v().getCallGraph(), mSet);
			egb.build("dddata/subjects/"+subjectName+"/SubjectMethod.dat",
					"dddata/subjects/"+subjectName+"/SubjectGraph.dat",
					"dddata/subjects/"+subjectName+"/SubjectCG.dat",
					null);
		} catch (FileNotFoundException e1) {
			e1.printStackTrace();
		}
		
		
		
	}

}
