package pku.edu.hocra.graph.ds;

import java.util.ArrayList;
import java.util.HashMap;

public class MultiMap<KeyType, ValueType> {
	protected HashMap< KeyType, ArrayList<ValueType> > mapToArray 
		= new HashMap< KeyType, ArrayList<ValueType> >();
	protected int itemNumber = 0;
	
	public boolean containsKey(KeyType key) {
		return mapToArray.containsKey(key);
	}
	
	public void put(KeyType key, ValueType value) {
		ArrayList<ValueType> valueArray;
		if (mapToArray.containsKey(key)) {
			valueArray = mapToArray.get(key);
			valueArray.add(value);
		}
		else {
			valueArray = new ArrayList<ValueType>();
			valueArray.add(value);
			mapToArray.put(key, valueArray);
		}
		itemNumber ++;
	}
	
	public ArrayList<ValueType> get(KeyType key) {
		if (mapToArray.containsKey(key))
			return mapToArray.get(key);
		else
			return new ArrayList<ValueType>();
	}
}
