package pku.edu.hocra.jimple;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

public class DriverGetJDK {
	
	private static void copyTo(File dest, File src) throws IOException {
		File outdir = new File("jdksrcX");
		if (!outdir.exists() && !outdir.isDirectory()) {
			outdir.mkdir();
		}
		BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(src)));
		BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(dest)));
		while (true) {
			String line = br.readLine();
			if (line == null) break;
			bw.write(line + "\n");
		}
		br.close();
		bw.close();
		
	}
	
	private static int getLOC(File file) throws IOException {
		int LOC = 0;
		BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(file)));
		while (br.readLine() != null) 
			LOC ++;
		br.close();
		return LOC;
	}
	
	public static void main(String[] args) throws IOException {
		
		Scanner sc = new Scanner(new FileInputStream("dddata\\library\\LibraryMethod.dat"));
		
		Set<String> set4class = new HashSet<String>();
		int ef = 0, nef = 0, tot = 0;
		while (sc.hasNextLine()) {
			String line = sc.nextLine();
			int ed = line.indexOf(":");
			if (line.substring(0, ed).indexOf("$") != -1) ed = line.substring(0, ed).indexOf("$"); 
			String classname = line.substring(1, ed);
			//System.out.println(classname);
			if (set4class.add(classname)) {
				String cn = classname.replace('.', '\\');
				File file = new File("jdksrc\\"+cn+".java");
				if (file.exists()) {
					ef ++;
					tot += getLOC(file);
					String cnd = classname.replaceAll("\\.", "");
					File destfile = new File("jdksrcX\\"+cnd+".java");
					copyTo(destfile, file);
				}
				else {
					nef ++;
					//System.err.println(classname + " " + line);
				}
			}
		}
		System.out.println(tot);
		
	}

}
