//
// Created by Wayne on 15/12/29.
//

#ifndef REACHABILITY_EDGE_H
#define REACHABILITY_EDGE_H


#include <cstdlib>
#include <cstddef>

class edge {
    int source;
    int target;
    int symbol;
public:
    edge() {};
    edge(int source, int target, int symbol);
    int get_source() const { return this->source; }
    int get_target() const { return this->target; }
    int get_symbol() const { return this->symbol; }
public:
    class hasher {
    public:
        size_t operator()(const edge& e) const {
            return (((10003UL * 99991UL + e.source) * 99991UL + e.target) * 99991UL);
        }
    };
    class key_equal {
    public:
        bool operator()(const edge &e1, const edge &e2) const {
            return (e1.source == e2.source && e1.target == e2.target);
        }
    };
public:
    static size_t encode(const edge &e);
    static edge decode(size_t code);
};


#endif //REACHABILITY_EDGE_H
