//
// Created by Wayne on 15/12/30.
//

#ifndef REACHABILITY_MULTILEVEL_QUEUE_H
#define REACHABILITY_MULTILEVEL_QUEUE_H


#include <queue>

using std::queue;
using std::vector;

template <class T>
class multilevel_queue {
    vector<queue<T>> queues;
    size_t count;
public:
    multilevel_queue() {
        count = 0;
    }
    multilevel_queue(size_t capacity) {
        count = 0;
        queues.resize(capacity);
    }
    void push(size_t level, T elem) {
        while (queues.size() <= level) {
            queues.push_back(queue<T>());
        }
        queues[level].push(elem);
        count += 1;
    }
    T pop() {
        for (size_t level = 0; level < queues.size(); level++) {
            if (!queues[level].empty()) {
                T res = queues[level].front();
                queues[level].pop();
                count -= 1;
                return res;
            }
        }
        throw "empty queue";
    }
    bool empty() const { return (count == 0); }
    size_t size() const { return count; }
    size_t get_levels() const { return queues.size(); }
};


#endif //REACHABILITY_MULTILEVEL_QUEUE_H
