//
// Created by Wayne on 15/12/29.
//

#include "premise.h"

using std::lower_bound;
using std::distance;
using std::unique;
using std::set_union;

premise_0::premise_0() { }

premise_1::premise_1(size_t p1) {
    this->p1 = p1;
}

premise_2::premise_2(size_t p1, size_t p2) {
    this->p1 = p1;
    this->p2 = p2;
}

premise_3::premise_3(size_t p1, size_t p2, size_t p3) {
    this->p1 = p1;
    this->p2 = p2;
    this->p3 = p3;
}

premise_4::premise_4(size_t p1, size_t p2, size_t p3, size_t p4) {
    this->p1 = p1;
    this->p2 = p2;
    this->p3 = p3;
    this->p4 = p4;
}

premise_5::premise_5(size_t p1, size_t p2, size_t p3, size_t p4, size_t p5) {
    this->p1 = p1;
    this->p2 = p2;
    this->p3 = p3;
    this->p4 = p4;
    this->p5 = p5;
}

premise_f::premise_f(const vector<size_t> &premise) {
    this->premise = premise;
    this->record_hash = 0;
    for (size_t t : premise) {
        this->record_hash = this->record_hash * 99991UL + t;
    }
}

premise_base* premise_0::merge(const premise_base *other) const {
    return other->merge_0(this);
}

premise_base* premise_1::merge(const premise_base *other) const {
    return other->merge_1(this);
}

premise_base* premise_2::merge(const premise_base *other) const {
    return other->merge_2(this);
}

premise_base* premise_3::merge(const premise_base *other) const {
    return other->merge_3(this);
}

premise_base* premise_4::merge(const premise_base *other) const {
    return other->merge_4(this);
}

premise_base* premise_5::merge(const premise_base *other) const {
    return other->merge_5(this);
}

premise_base* premise_f::merge(const premise_base *other) const {
    return other->merge_f(this);
}

premise_base* premise_0::merge_0(const premise_0 *other) const {
    return new premise_0;
}

premise_base* premise_0::merge_1(const premise_1 *other) const {
    return new premise_1(other);
}

premise_base* premise_0::merge_2(const premise_2 *other) const {
    return new premise_2(other);
}

premise_base* premise_0::merge_3(const premise_3 *other) const {
    return new premise_3(other);
}

premise_base* premise_0::merge_4(const premise_4 *other) const {
    return new premise_4(other);
}

premise_base* premise_0::merge_5(const premise_5 *other) const {
    return new premise_5(other);
}

premise_base* premise_0::merge_f(const premise_f *other) const {
    return new premise_f(other);
}

premise_base* premise_1::merge_0(const premise_0 *other) const {
    return new premise_1(this);
}

premise_base* premise_1::merge_1(const premise_1 *other) const {
    if (this->p1 == other->p1) {
        return new premise_1(other);
    } else if (this->p1 < other->p1) {
        return new premise_2(this->p1, other->p1);
    } else {
        return new premise_2(other->p1, this->p1);
    }
}

premise_base* premise_1::merge_2(const premise_2 *other) const {
    if (this->p1 == other->get_p1() || this->p1 == other->get_p2()) {
        return new premise_2(other);
    } else if (this->p1 < other->get_p1()) {
        return new premise_3(this->p1, other->get_p1(), other->get_p2());
    } else if (this->p1 < other->get_p2()) {
        return new premise_3(other->get_p1(), this->p1, other->get_p2());
    } else {
        return new premise_3(other->get_p1(), other->get_p2(), this->p1);
    }
}

premise_base* premise_1::merge_3(const premise_3 *other) const {
    if (this->p1 == other->get_p1() || this->p1 == other->get_p2() || this->p1 == other->get_p3()) {
        return new premise_3(other);
    } else if (this->p1 < other->get_p1()) {
        return new premise_4(this->p1, other->get_p1(), other->get_p2(), other->get_p3());
    } else if (this->p1 < other->get_p2()) {
        return new premise_4(other->get_p1(), this->p1, other->get_p2(), other->get_p3());
    } else if (this->p1 < other->get_p3()) {
        return new premise_4(other->get_p1(), other->get_p2(), this->p1, other->get_p3());
    } else {
        return new premise_4(other->get_p1(), other->get_p2(), other->get_p3(), this->p1);
    }
}

premise_base* premise_1::merge_4(const premise_4 *other) const {
    if (this->p1 == other->get_p1() || this->p1 == other->get_p2() || this->p1 == other->get_p3() || this->p1 == other->get_p4()) {
        return new premise_4(other);
    } else if (this->p1 < other->get_p1()) {
        return new premise_5(this->p1, other->get_p1(), other->get_p2(), other->get_p3(), other->get_p4());
    } else if (this->p1 < other->get_p2()) {
        return new premise_5(other->get_p1(), this->p1, other->get_p2(), other->get_p3(), other->get_p4());
    } else if (this->p1 < other->get_p3()) {
        return new premise_5(other->get_p1(), other->get_p2(), this->p1, other->get_p3(), other->get_p4());
    } else if (this->p1 < other->get_p4()) {
        return new premise_5(other->get_p1(), other->get_p2(), other->get_p3(), this->p1, other->get_p4());
    } else {
        return new premise_5(other->get_p1(), other->get_p2(), other->get_p3(), other->get_p4(), this->p1);
    }
}

premise_base* premise_1::merge_5(const premise_5 *other) const {
    if (this->p1 == other->get_p1() || this->p1 == other->get_p2() || this->p1 == other->get_p3() || this->p1 == other->get_p4() || this->p1 == other->get_p5()) {
        return new premise_5(other);
    } else if (this->p1 < other->get_p1()) {
        return new premise_f(
                {this->p1, other->get_p1(), other->get_p2(), other->get_p3(), other->get_p4(), other->get_p5()});
    } else if (this->p1 < other->get_p2()) {
        return new premise_f(
                {other->get_p1(), this->p1, other->get_p2(), other->get_p3(), other->get_p4(), other->get_p5()});
    } else if (this->p1 < other->get_p3()) {
        return new premise_f(
                {other->get_p1(), other->get_p2(), this->p1, other->get_p3(), other->get_p4(), other->get_p5()});
    } else if (this->p1 < other->get_p4()) {
        return new premise_f(
                {other->get_p1(), other->get_p2(), other->get_p3(), this->p1, other->get_p4(), other->get_p5()});
    } else if (this->p1 < other->get_p5()) {
        return new premise_f(
                {other->get_p1(), other->get_p2(), other->get_p3(), other->get_p4(), this->p1, other->get_p5()});
    } else {
        return new premise_f(
                {other->get_p1(), other->get_p2(), other->get_p3(), other->get_p4(), other->get_p5(), this->p1});
    }
}

premise_base* premise_1::merge_f(const premise_f *other) const {
    vector<size_t> premise = other->get_premise();
    auto it = lower_bound(premise.begin(), premise.end(), this->p1);
    if (it == premise.end() || *it != this->p1) {
        premise.insert(it, this->p1);
    }
    return new premise_f(premise);
}

premise_base* premise_2::merge_0(const premise_0 *other) const {
    return new premise_2(this);
}

premise_base* premise_2::merge_1(const premise_1 *other) const {
    return other->merge_2(this);
}

premise_base* premise_2::merge_2(const premise_2 *other) const {
    size_t a[2] = {this->p1, this->p2};
    size_t b[2] = {other->p1, other->p2};
    size_t c[4];
    long d = set_union(a, a + 2, b, b+ 2, c) - c;
    if (d == 2) {
        return new premise_2(c[0], c[1]);
    } else if (d == 3) {
        return new premise_3(c[0], c[1], c[2]);
    } else {
        return new premise_4(c[0], c[1], c[2], c[3]);
    }
}

premise_base* premise_2::merge_3(const premise_3 *other) const {
    size_t a[2] = {this->p1, this->p2};
    size_t b[3] = {other->get_p1(), other->get_p2(), other->get_p3()};
    size_t c[5];
    long d = set_union(a, a + 2, b, b + 3, c) - c;
    if (d == 3) {
        return new premise_3(c[0], c[1], c[2]);
    } else if (d == 4) {
        return new premise_4(c[0], c[1], c[2], c[3]);
    } else {
        return new premise_5(c[0], c[1], c[2], c[3], c[4]);
    }
}

premise_base* premise_2::merge_4(const premise_4 *other) const {
    size_t a[2] = {this->p1, this->p2};
    size_t b[4] = {other->get_p1(), other->get_p2(), other->get_p3(), other->get_p4()};
    size_t c[6];
    long d = set_union(a, a + 2, b, b + 4, c) - c;
    if (d == 4) {
        return new premise_4(c[0], c[1], c[2], c[3]);
    } else if (d == 5) {
        return new premise_5(c[0], c[1], c[2], c[3], c[4]);
    } else {
        return new premise_f({c[0], c[1], c[2], c[3], c[4], c[5]});
    }
}

premise_base* premise_2::merge_5(const premise_5 *other) const {
    size_t a[2] = {this->p1, this->p2};
    size_t b[5] = {other->get_p1(), other->get_p2(), other->get_p3(), other->get_p4(), other->get_p5()};
    size_t c[7];
    long d = set_union(a, a + 2, b, b + 5, c) - c;
    if (d == 5) {
        return new premise_5(c[0], c[1], c[2], c[3], c[4]);
    } else {
        return new premise_f(vector<size_t>(c, c + d));
    }
}

premise_base* premise_2::merge_f(const premise_f *other) const {
    size_t a[2] = {this->p1, this->p2};
    vector<size_t> premise(2 + other->get_premise().size());
    premise.resize(distance(premise.begin(), set_union(a, a + 2, other->get_premise().begin(), other->get_premise().end(), premise.begin())));
    return new premise_f(premise);
}

premise_base* premise_3::merge_0(const premise_0 *other) const {
    return new premise_3(this);
}

premise_base* premise_3::merge_1(const premise_1 *other) const {
    return other->merge_3(this);
}

premise_base* premise_3::merge_2(const premise_2 *other) const {
    return other->merge_3(this);
}

premise_base* premise_3::merge_3(const premise_3 *other) const {
    size_t a[3] = {this->p1, this->p2, this->p3};
    size_t b[3] = {other->p1, other->p2, other->p3};
    size_t c[6];
    long d = set_union(a, a + 3, b, b + 3, c) - c;
    if (d == 3) {
        return new premise_3(c[0], c[1], c[2]);
    } else if (d == 4) {
        return new premise_4(c[0], c[1], c[2], c[3]);
    } else if (d == 5) {
        return new premise_5(c[0], c[1], c[2], c[3], c[4]);
    } else {
        return new premise_f({c[0], c[1], c[2], c[3], c[4], c[5]});
    }
}

premise_base* premise_3::merge_4(const premise_4 *other) const {
    size_t a[3] = {this->p1, this->p2, this->p3};
    size_t b[4] = {other->get_p1(), other->get_p2(), other->get_p3(), other->get_p4()};
    size_t c[7];
    long d = set_union(a, a + 3, b, b + 4, c) - c;
    if (d == 4) {
        return new premise_4(c[0], c[1], c[2], c[3]);
    } else if (d == 5) {
        return new premise_5(c[0], c[1], c[2], c[3], c[4]);
    } else {
        return new premise_f(vector<size_t>(c, c + d));
    }
}

premise_base* premise_3::merge_5(const premise_5 *other) const {
    size_t a[3] = {this->p1, this->p2, this->p3};
    size_t b[5] = {other->get_p1(), other->get_p2(), other->get_p3(), other->get_p4(), other->get_p5()};
    size_t c[8];
    long d = set_union(a, a + 3, b, b + 5, c) - c;
    if (d == 5) {
        return new premise_5(c[0], c[1], c[2], c[3], c[4]);
    } else {
        return new premise_f(vector<size_t>(c, c + d));
    }
}

premise_base* premise_3::merge_f(const premise_f *other) const {
    size_t a[3] = {this->p1, this->p2, this->p3};
    vector<size_t> premise(3 + other->get_premise().size());
    premise.resize(distance(premise.begin(), set_union(a, a + 3, other->get_premise().begin(), other->get_premise().end(), premise.begin())));
    return new premise_f(premise);
}

premise_base* premise_4::merge_0(const premise_0 *other) const {
    return new premise_4(this);
}

premise_base* premise_4::merge_1(const premise_1 *other) const {
    return other->merge_4(this);
}

premise_base* premise_4::merge_2(const premise_2 *other) const {
    return other->merge_4(this);
}

premise_base* premise_4::merge_3(const premise_3 *other) const {
    return other->merge_4(this);
}

premise_base* premise_4::merge_4(const premise_4 *other) const {
    size_t a[4] = {this->p1, this->p2, this->p3, this->p4};
    size_t b[4] = {other->p1, other->p2, other->p3, other->p4};
    size_t c[8];
    long d = set_union(a, a + 4, b, b + 4, c) - c;
    if (d == 4) {
        return new premise_4(c[0], c[1], c[2], c[3]);
    } else if (d == 5) {
        return new premise_5(c[0], c[1], c[2], c[3], c[4]);
    } else {
        return new premise_f(vector<size_t>(c, c + d));
    }
}

premise_base* premise_4::merge_5(const premise_5 *other) const {
    size_t a[4] = {this->p1, this->p2, this->p3, this->p4};
    size_t b[5] = {other->get_p1(), other->get_p2(), other->get_p3(), other->get_p4(), other->get_p5()};
    size_t c[9];
    long d = set_union(a, a + 4, b, b + 5, c) - c;
    if (d == 5) {
        return new premise_5(c[0], c[1], c[2], c[3], c[4]);
    } else {
        return new premise_f(vector<size_t>(c, c + d));
    }
}

premise_base* premise_4::merge_f(const premise_f *other) const {
    size_t a[4] = {this->p1, this->p2, this->p3, this->p4};
    vector<size_t> premise(4 + other->get_premise().size());
    premise.resize(distance(premise.begin(), set_union(a, a + 4, other->get_premise().begin(), other->get_premise().end(), premise.begin())));
    return new premise_f(premise);
}

premise_base* premise_5::merge_0(const premise_0 *other) const {
    return new premise_5(this);
}

premise_base* premise_5::merge_1(const premise_1 *other) const {
    return other->merge_5(this);
}

premise_base* premise_5::merge_2(const premise_2 *other) const {
    return other->merge_5(this);
}

premise_base* premise_5::merge_3(const premise_3 *other) const {
    return other->merge_5(this);
}

premise_base* premise_5::merge_4(const premise_4 *other) const {
    return other->merge_5(this);
}

premise_base* premise_5::merge_5(const premise_5 *other) const {
    size_t a[5] = {this->p1, this->p2, this->p3, this->p4, this->p5};
    size_t b[5] = {other->p1, other->p2, other->p3, other->p4, other->p5};
    size_t c[10];
    long d = set_union(a, a + 5, b, b + 5, c) - c;
    if (d == 5) {
        return new premise_5(c[0], c[1], c[2], c[3], c[4]);
    } else {
        return new premise_f(vector<size_t>(c, c + d));
    }
}

premise_base* premise_5::merge_f(const premise_f *other) const {
    size_t a[5] = {this->p1, this->p2, this->p3, this->p4, this->p5};
    vector<size_t> premise(5 + other->get_premise().size());
    premise.resize(distance(premise.begin(), set_union(a, a + 5, other->get_premise().begin(), other->get_premise().end(), premise.begin())));
    return new premise_f(premise);
}

premise_base* premise_f::merge_0(const premise_0 *other) const {
    return new premise_f(this);
}

premise_base* premise_f::merge_1(const premise_1 *other) const {
    return other->merge_f(this);
}

premise_base* premise_f::merge_2(const premise_2 *other) const {
    return other->merge_f(this);
}

premise_base* premise_f::merge_3(const premise_3 *other) const {
    return other->merge_f(this);
}

premise_base* premise_f::merge_4(const premise_4 *other) const {
    return other->merge_f(this);
}

premise_base* premise_f::merge_5(const premise_5 *other) const {
    return other->merge_f(this);
}

premise_base* premise_f::merge_f(const premise_f *other) const {
    vector<size_t> premise(this->premise.size() + other->premise.size());
    premise.resize(distance(premise.begin(), set_union(this->premise.begin(), this->premise.end(), other->premise.begin(), other->premise.end(), premise.begin())));
    return new premise_f(premise);
}

size_t premise_1::get_p1() const {
    return this->p1;
}

premise_1::premise_1(const premise_1 *other) {
    this->p1 = other->p1;
}

size_t premise_2::get_p1() const {
    return this->p1;
}

size_t premise_2::get_p2() const {
    return this->p2;
}

premise_2::premise_2(const premise_2 *other) {
    this->p1 = other->p1;
    this->p2 = other->p2;
}

size_t premise_3::get_p1() const {
    return this->p1;
}

size_t premise_3::get_p2() const {
    return this->p2;
}

size_t premise_3::get_p3() const {
    return this->p3;
}

premise_3::premise_3(const premise_3 *other) {
    this->p1 = other->p1;
    this->p2 = other->p2;
    this->p3 = other->p3;
}

size_t premise_4::get_p1() const {
    return this->p1;
}

size_t premise_4::get_p2() const {
    return this->p2;
}

size_t premise_4::get_p3() const {
    return this->p3;
}

size_t premise_4::get_p4() const {
    return this->p4;
}

premise_4::premise_4(const premise_4 *other) {
    this->p1 = other->p1;
    this->p2 = other->p2;
    this->p3 = other->p3;
    this->p4 = other->p4;
}

size_t premise_5::get_p1() const {
    return this->p1;
}

size_t premise_5::get_p2() const {
    return this->p2;
}

size_t premise_5::get_p3() const {
    return this->p3;
}

size_t premise_5::get_p4() const {
    return this->p4;
}

size_t premise_5::get_p5() const {
    return this->p5;
}

premise_5::premise_5(const premise_5 *other) {
    this->p1 = other->p1;
    this->p2 = other->p2;
    this->p3 = other->p3;
    this->p4 = other->p4;
    this->p5 = other->p5;
}

const vector<size_t>& premise_f::get_premise() const {
    return this->premise;
}

premise_f::premise_f(const premise_f *other) {
    this->premise = other->premise;
    this->record_hash = other->record_hash;
}

bool premise_0::is_covered_by(const premise_base *other) const {
    return true;
}

bool premise_1::is_covered_by(const premise_base *other) const {
    return other->can_cover_1(this);
}

bool premise_2::is_covered_by(const premise_base *other) const {
    return other->can_cover_2(this);
}

bool premise_3::is_covered_by(const premise_base *other) const {
    return other->can_cover_3(this);
}

bool premise_4::is_covered_by(const premise_base *other) const {
    return other->can_cover_4(this);
}

bool premise_5::is_covered_by(const premise_base *other) const {
    return other->can_cover_5(this);
}

bool premise_f::is_covered_by(const premise_base *other) const {
    return other->can_cover_f(this);
}

bool premise_1::can_cover_1(const premise_1 *other) const {
    return (this->p1 == other->p1);
}

bool premise_2::can_cover_1(const premise_1 *other) const {
    size_t p1 = other->get_p1();
    return (this->p1 == p1 || this->p2 == p1);
}

bool premise_2::can_cover_2(const premise_2 *other) const {
    return (this->p1 == other->p1 && this->p2 == other->p2);
}

bool premise_3::can_cover_1(const premise_1 *other) const {
    return (this->p1 == other->get_p1() || this->p2 == other->get_p1() || this->p3 == other->get_p1());
}

bool premise_3::can_cover_2(const premise_2 *other) const {
    size_t p1 = other->get_p1();
    size_t p2 = other->get_p2();
    return ((this->p1 == p1 && (this->p2 == p2 || this->p3 == p2)) || (this->p2 == p1 && this->p3 == p2));
}

bool premise_3::can_cover_3(const premise_3 *other) const {
    return (this->p1 == other->p1 && this->p2 == other->p2 && this->p3 == other->p3);
}

bool premise_4::can_cover_1(const premise_1 *other) const {
    size_t p1 = other->get_p1();
    return (this->p1 == p1 || this->p2 == p1 || this->p3 == p1 || this->p4 == p1);
}

bool premise_4::can_cover_2(const premise_2 *other) const {
    size_t p1 = other->get_p1();
    size_t p2 = other->get_p2();
    return ((this->p1 == p1 && (this->p2 == p2 || this->p3 == p2 || this->p4 == p2)) ||
            (this->p2 == p1 && (this->p3 == p2 || this->p4 == p2)) ||
            (this->p3 == p1 && this->p4 == p2));
}

bool premise_4::can_cover_3(const premise_3 *other) const {
    size_t p1 = other->get_p1();
    size_t p2 = other->get_p2();
    size_t p3 = other->get_p3();
    return ((this->p1 == p1 && ((this->p2 == p2 && (this->p3 == p3 || this->p4 == p3)) || (this->p3 == p2 && this->p4 == p3))) ||
            (this->p2 == p1 && this->p3 == p2 && this->p4 == p3));
}

bool premise_4::can_cover_4(const premise_4 *other) const {
    return (this->p1 == other->p1 && this->p2 == other->p2 && this->p3 == other->p3 && this->p4 == other->p4);
}

bool premise_5::can_cover_1(const premise_1 *other) const {
    size_t p1 = other->get_p1();
    return (this->p1 == p1 || this->p2 == p1 || this->p3 == p1 || this->p4 == p1 || this->p5 == p1);
}

bool premise_5::can_cover_2(const premise_2 *other) const {
    size_t p1 = other->get_p1();
    size_t p2 = other->get_p2();
    return ((this->p1 == p1 && (this->p2 == p2 || this->p3 == p2 || this->p4 == p2 || this->p5 == p2)) ||
            (this->p2 == p1 && (this->p3 == p2 || this->p4 == p2 || this->p5 == p2)) ||
            (this->p3 == p1 && (this->p4 == p2 || this->p5 == p2)) ||
            (this->p4 == p1 && this->p5 == p2));
}

bool premise_5::can_cover_3(const premise_3 *other) const {
    size_t p1 = other->get_p1();
    size_t p2 = other->get_p2();
    size_t p3 = other->get_p3();
    return ((this->p1 == p1 && ((this->p2 == p2 && (this->p3 == p3 || this->p4 == p3 || this->p5 == p3)) ||
                                (this->p3 == p2 && (this->p4 == p3 || this->p5 == p3)) ||
                                (this->p4 == p2 && this->p5 == p3))) ||
            (this->p2 == p1 && ((this->p3 == p2 && (this->p4 == p3 || this->p5 == p3)) ||
                                (this->p4 == p2 && this->p5 == p3))) ||
            (this->p3 == p1 && this->p4 == p2 && this->p5 == p3));
}

bool premise_5::can_cover_4(const premise_4 *other) const {
    size_t p1 = other->get_p1();
    size_t p2 = other->get_p2();
    size_t p3 = other->get_p3();
    size_t p4 = other->get_p4();
    return ((this->p1 == p1 && ((this->p2 == p2 && ((this->p3 == p3 && (this->p4 == p4 || this->p5 == p4)) ||
                                                    (this->p4 == p3 && this->p5 == p4))) ||
                                (this->p3 == p2 && this->p4 == p3 && this->p5 == p4))) ||
            (this->p2 == p1 && this->p3 == p2 && this->p4 == p3 && this->p5 == p4));
}

bool premise_5::can_cover_5(const premise_5 *other) const {
    return (this->p1 == other->p1 && this->p2 == other->p2 && this->p3 == other->p3 && this->p4 == other->p4 && this->p5 == other->p5);
}

bool premise_f::can_cover_1(const premise_1 *other) const {
    size_t p1 = other->get_p1();
    auto it1 = lower_bound(this->premise.begin(), this->premise.end(), p1);
    return (it1 != this->premise.end() && *it1 == p1);
}

bool premise_f::can_cover_2(const premise_2 *other) const {
    size_t p1 = other->get_p1();
    size_t p2 = other->get_p2();
    auto it1 = lower_bound(this->premise.begin(), this->premise.end(), p1);
    if (it1 == this->premise.end() || *it1 != p1) {
        return false;
    }
    auto it2 = lower_bound(it1, this->premise.end(), p2);
    return (it2 != this->premise.end() && *it2 == p2);
}

bool premise_f::can_cover_3(const premise_3 *other) const {
    size_t p1 = other->get_p1();
    size_t p2 = other->get_p2();
    size_t p3 = other->get_p3();
    auto it1 = lower_bound(this->premise.begin(), this->premise.end(), p1);
    if (it1 == this->premise.end() || *it1 != p1) {
        return false;
    }
    auto it2 = lower_bound(it1, this->premise.end(), p2);
    if (it2 == this->premise.end() || *it2 != p2) {
        return false;
    }
    auto it3 = lower_bound(it2, this->premise.end(), p3);
    return (it3 != this->premise.end() && *it3 == p3);
}

bool premise_f::can_cover_4(const premise_4 *other) const {
    size_t p1 = other->get_p1();
    size_t p2 = other->get_p2();
    size_t p3 = other->get_p3();
    size_t p4 = other->get_p4();
    auto it1 = lower_bound(this->premise.begin(), this->premise.end(), p1);
    if (it1 == this->premise.end() || *it1 != p1) {
        return false;
    }
    auto it2 = lower_bound(it1, this->premise.end(), p2);
    if (it2 == this->premise.end() || *it2 != p2) {
        return false;
    }
    auto it3 = lower_bound(it2, this->premise.end(), p3);
    if (it3 == this->premise.end() || *it3 != p3) {
        return false;
    }
    auto it4 = lower_bound(it3, this->premise.end(), p4);
    return (it4 != this->premise.end() && *it4 == p4);
}

bool premise_f::can_cover_5(const premise_5 *other) const {
    size_t p1 = other->get_p1();
    size_t p2 = other->get_p2();
    size_t p3 = other->get_p3();
    size_t p4 = other->get_p4();
    size_t p5 = other->get_p5();
    auto it1 = lower_bound(this->premise.begin(), this->premise.end(), p1);
    if (it1 == this->premise.end() || *it1 != p1) {
        return false;
    }
    auto it2 = lower_bound(it1, this->premise.end(), p2);
    if (it2 == this->premise.end() || *it2 != p2) {
        return false;
    }
    auto it3 = lower_bound(it2, this->premise.end(), p3);
    if (it3 == this->premise.end() || *it3 != p3) {
        return false;
    }
    auto it4 = lower_bound(it3, this->premise.end(), p4);
    if (it4 == this->premise.end() || *it4 != p4) {
        return false;
    }
    auto it5 = lower_bound(it4, this->premise.end(), p5);
    return (it5 != this->premise.end() && *it5 == p5);
}

bool premise_f::can_cover_f(const premise_f *other) const {
    if (this->premise.size() < other->premise.size()) {
        return false;
    }
    auto last = this->premise.begin();
    for (size_t p : other->premise) {
        auto it = lower_bound(last, this->premise.end(), p);
        if (it == this->premise.end() || *it != p) {
            return false;
        }
        last = it;
    }
    return true;
}

