//
// Created by Wayne on 16/1/23.
//

#ifndef REACHABILITY_TAL_EDGE_H
#define REACHABILITY_TAL_EDGE_H


class tal_edge_base {
    int symbol;
public:
    tal_edge_base(int symbol);
    int get_symbol() const;
    virtual int get_order() const = 0;
    virtual ~tal_edge_base() {}
};

class tal_fst_edge : public tal_edge_base {
    int source;
    int target;
public:
    tal_fst_edge(int symbol, int source, int target);
    int get_source() const;
    int get_target() const;
    int get_order() const;
};

class tal_snd_edge : public tal_edge_base {
    int source;
    int target;
    int mid_source;
    int mid_target;
public:
    tal_snd_edge(int symbol, int source, int target, int mid_source, int mid_target);
    int get_source() const;
    int get_target() const;
    int get_mid_source() const;
    int get_mid_target() const;
    int get_order() const;
};


#endif //REACHABILITY_TAL_EDGE_H
